(function($){
$.fn.xdGallery = function( galleryOptions ){
	var defaultOptions = {
		'shag':200,	 // px    
		'speed':200, //        (shag)
		'itemClass':'itemImage',
		'easingWheel':'swing', //     
		'easingNext':'linear', //      next,prev
		'easingDrag':'linear', //    ,  
		'invertWheel':1,//      
		'invertNext':-1, //      next  prev
		'orient':'horizontal', //  , horizontal( )  vertical
		'onHoverNext':false, //       next  prev
		'navigation':false, // ,  false,  .  >0        ,   0,       items
	};
	//     ,    
	var options = $.extend({}, defaultOptions, galleryOptions);
	var hor = ( options.orient=='horizontal' );
	var extent = hor?'width':'height'; //    ,      
	var axis = hor?'marginLeft':'marginTop'; //    ,       
	var clientAxis = hor?'clientX':'clientY'; //    ,       
	var caruselWidth = function($gallery){
		var w = 0;
		$gallery._items.each(function(){
			w+=$(this)[extent]()+5;
		})
		return w;
	}
	var margin = function(step){
		var a = {};
		a[axis] = step;
		return a;
	}
	var step = function(direct,shag,speed,easing,$gallery){
		var marginLeft = parseInt( $gallery._carusel.css( axis ) );//   
		var wdth = caruselWidth($gallery) - $gallery._galleryWidth; //   
 		if( direct > 0 ){
			//  
			//    + shag    
			if( wdth >= Math.abs(marginLeft)+shag ){
				//     shag
				$gallery._carusel.stop().animate( margin('-='+shag+'px') ,speed,easing)
			//    ,  
			}else{ 
				if(wdth == Math.abs(marginLeft))return false;
				$gallery._carusel.stop().animate( margin('-'+wdth+'px') ,speed,easing);
			}
		}else{
			//    ,     
			if( 0 <= Math.abs(marginLeft)- shag ){
				$gallery._carusel.stop().animate( margin('+='+ shag+'px'),speed,easing)
			}else{
				if( 0 == Math.abs(marginLeft) )return false;
				$gallery._carusel.stop().animate( margin('0px'),speed,easing);
			}
		}
		return true;
	}
	
	var gallery = function(obj){
		var $gallery = this;
		this._oldgallery = $(obj); 								//   
		if( !this._oldgallery.children().length )return false;
		this._itemTag = this._oldgallery.children()[0].tagName;
		this._oldgallery.children().addClass( options.itemClass );//    
		this._gallery = $('<div class="gallery '+options.orient+'">'+
			'<div class="prev"></div><!--  -->'+
			'<div class="next"></div><!--  -->'+
			'<div class="navigation"></div><!---->'+
			'<div class="carusel">'+this._oldgallery.html()+
				'<div style="clear:both"></div>'+
			'</div>'+
		'</div>');
		this._oldgallery.replaceWith(this._gallery);
		this._carusel = this._gallery.find('.carusel');			//    
		this._items = this._carusel.find( this._itemTag ); 		//     
		this._galleryWidth = this._gallery[extent]()			// () 
		if( options.navigation===false ){
			this._gallery.find('div.navigation').hide();
		}else{
			var cnt = parseInt(options.navigation);
			if( cnt == 0 )cnt = $gallery._items.length;
			var s = '';
			for(var i=0;i<cnt;i++){
				s+='<div class="'+i+(!i?' active':'')+'">&nbsp;</div>';
			}
			this._gallery.find('div.navigation').html(s) //      
				.css(hor?'left':'top' , this._galleryWidth/2-( cnt*(16+3) )/2)
				.find('div').click(function(){
					var wdth = caruselWidth($gallery) - $gallery._galleryWidth; //   
					$gallery._carusel.stop().animate( margin( '-'+((wdth/cnt)*parseInt(this.className))+'px' ) ,speed,options.easingNext);
					$gallery._gallery.find('div.navigation').children().removeClass('active');
					$(this).addClass('active');
				});

		}
		this._gallery.find('div.next,div.prev').hover(function(){
			$(this).stop().animate({'opacity':'0.8'},400);
			if( options.onHoverNext ){
				step((this.className=='next'?1:-1)*options.invertNext,options.shag*1000,options.speed*20,options.easingNext,$gallery);
			}
		},function(){
			$(this).stop().animate({'opacity':'0.5'},400);
			if( options.onHoverNext ){
				$gallery._carusel.stop();
			}
		}).click(function(){
			step((this.className=='next'?1:-1)*options.invertNext,options.shag,options.speed,options.easingNext,$gallery);
		})
		if( this._gallery.mousewheel ){
			this._gallery.mousewheel(function(event,delta){
				var evnt = event || window.event;
				if( step(-delta*options.invertWheel,options.shag,options.speed,options.easingWheel,$gallery) ){
					evnt.stopPropagation&&evnt.stopPropagation(); //  , 
					evnt.preventDefault&&evnt.preventDefault();
				}
			})
		}
		var oldx =0 ,oldy = 0;
		var startDrag = false;
		var oldMargin = 0; 
		this._carusel.mousedown(function(event){
			var evnt = event || window.event;
			if (evnt.preventDefault) evnt.preventDefault()
		}).click(function(){
			return false;
		})
		var oldmovex = 1;
		var oldmovetime = 1;
		var carWidth = 0;
		var curSpeedObj = {'x':0,'t':0};
		var measureSpeed = function( clientX ){
			var curtime  = new Date().getTime();
			curSpeedObj.x = Math.abs(clientX-oldmovex);
			curSpeedObj.t = curtime-oldmovetime;
			oldmovex = clientX;
			oldmovetime = curtime;
		}
		this._carusel.mousedown(function(event){
			var evnt = event || window.event;
			oldx = evnt.clientX;
			carWidth = caruselWidth($gallery);
			oldMargin =  parseInt( $gallery._carusel.css(axis) )
			startDrag = true;
		})
		$(window).mousemove(function(event){
			if( startDrag ){
				var evnt = event || window.event;
				measureSpeed(evnt[clientAxis]);
				var shg = evnt[clientAxis]-oldx;
				if(  Math.abs(oldMargin) - shg <= carWidth - $gallery._galleryWidth &&  Math.abs(oldMargin) - shg >= 0)
					$gallery._carusel.css(axis,oldMargin+shg);
				else{
					if(Math.abs(oldMargin) - shg<=0)$gallery._carusel.css(axis,'0px');else $gallery._carusel.css(axis,'-'+(carWidth-$gallery._galleryWidth)+'px');
				}
			}
		})
		$(window).mouseup(function(event){
			if(startDrag){
				var evnt = event || window.event;
				startDrag = false;
				if(curSpeedObj.x/curSpeedObj.t>0.5){
					step(-(evnt[clientAxis]-oldx),curSpeedObj.x*20,curSpeedObj.t*20,options.easingDrag,$gallery);
					curSpeedObj.x = curSpeedObj.t = 0;
				}
			}
		});
	}
	if (this.length > 0){
		this.each(function(){ 
			var gall = new gallery(this);
		});
	}
	return this;
}
})(jQuery);